package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.DescontoContratoDAO;
import com.rjconsultores.ventaboletos.entidad.DescontoContrato;

@SuppressWarnings("unchecked")
@Repository("descontoContratoDAO")
public class DescontoContratoHibernateDAO extends GenericHibernateDAO<DescontoContrato, Long> implements DescontoContratoDAO {

    @Autowired
    public DescontoContratoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<DescontoContrato> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

	@Override
	public boolean gravarDescontosContrato(List<DescontoContrato> descontos) {

		for (DescontoContrato desconto : descontos) {
			if(desconto.getDescontoContratoId() == null) {
				suscribir(desconto);
			}else {
				actualizacion(desconto);
			}
		}

		return true;
	}
}
